/* -*- Mode: C; tab-width: 5; indent-tabs-mode: t; c-basic-offset: 5 -*- */
/*
  Additions to NetworkManager, network-manager-applet and modemmanager
  for supporting Ericsson modules like F3507g.

  Author: Per Hallsmark <per@hallsmark.se>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef NM_GSM_MODEM_MBM_H
#define NM_GSM_MODEM_MBM_H

#include <nm-gsm-modem.h>

G_BEGIN_DECLS

#define NM_TYPE_GSM_MODEM_MBM            (nm_gsm_modem_mbm_get_type ())
#define NM_GSM_MODEM_MBM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NM_TYPE_GSM_MODEM_MBM, NMGsmModemMbm))
#define NM_GSM_MODEM_MBM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  NM_TYPE_GSM_MODEM_MBM, NMGsmModemMbmClass))
#define NM_IS_GSM_MODEM_MBM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NM_TYPE_GSM_MODEM_MBM))
#define NM_IS_GSM_MODEM_MBM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  NM_TYPE_GSM_MODEM_MBM))
#define NM_GSM_MODEM_MBM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  NM_TYPE_GSM_MODEM_MBM, NMGsmModemMbmClass))

typedef struct {
	NMGsmModem parent;
} NMGsmModemMbm;

typedef struct {
	NMGsmModemClass parent;
} NMGsmModemMbmClass;

GType nm_gsm_modem_mbm_get_type (void);

NMDevice *nm_gsm_modem_mbm_new (const char *path, const char *data_device,
						  const char *driver);

G_END_DECLS

#endif /* NM_GSM_MODEM_MBM_H */
